<?php

########################################
##  BOLTWIRE START SCRIPT             ##
##  Copyright 2015 Dan Vis            ##
##  See license.txt for details       ##
########################################

## USE THIS SCRIPT TO CREATE NEW SITES. NAVIGATE TO SCRIPT AND FOLLOW ONSCREEN INSTRUCTIONS
## FOR DOCUMENTATION GO TO WWW.BOLTWIRE.COM

// User configurable variables. Modify carefully and test thoroughly for non standard installations
// Then, save script to a new name so it is not overwritten, and disable start.php by setting password to false
// function pp($text) { print_r($text); die(); }  // used for debugging line
$boltwire = "../boltwire";  // path from field index to boltwire
$field = '';  // location of field folder relative to root
$root = "..";  // path from start to root
$htcodes = '.htcodes';

if (file_exists($htcodes)) {
	$handle = fopen($htcodes, "rb");
	$content = fread($handle, filesize($htcodes));
	fclose($handle);
	$pass = trim($content);
	}
if (isset($_POST['site'])) $site = "http://$_SERVER[HTTP_HOST]/$field$_POST[site]/index.php";
else $site = '';
$r = rand(1000,9999) . rand(1000,9999);
if (! file_exists("$root/index.php")) $root_exists = "<tr><td>Root Domain:</td><td><input type=radio name='root' value='yes'> Yes <input type=radio name='root' value='no' checked> No</td><td><i>Create a php forwarder in the root directory.</i></td></tr>";
else $root_exists = "<tr><td>Root Domain:</td><td><i>Not available</i></td><td><i>A php forwarder already exists in the root directory.</i></td></tr>";

// PAGES DISPLAYED IN THIS SCRIPT
$page['welcome'] = "<h1>Welcome to BoltWire</h1>
Your software is installed, and ready to help you create powerful interactive sites.<br><br>
To secure your installation, please enter a system password. It must contain at least eight characters. You will need this password each time you create a new site.<br><br>
To disable this script, and create your sites manually, set the password to 'false'.<br><br>
<form action='start.php' method='post'>Create password:&nbsp;&nbsp;&nbsp;<input type=password name=password> <input type=submit value='SUBMIT'></form>";

$page['setup'] = "<h1>BoltWire Setup</h1>
Use this form to create a new site. We will configure your settings for you:<br>
<form action='start.php' method='post'><br>
<table cellpadding=3px cellspacing=0>
<tr><td>Password:</td><td><input type=password name='password'></td><td><i>Enter your system password here.</i></td></tr>
<tr><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td></tr>
<tr><td>Site Name: </td><td><input type=text name='site'></td><td><i>Choose a site id--one word, no spaces, lower case.</i></td></tr>
<tr><td>Superadmin:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><input type=text name='admin' value='admin'>&nbsp;&nbsp;</td><td><i>User with maximum authority--one word, no spaces, lower case.</i></td></tr>
<tr><td>Encryption:</td><td><input type=radio name='key' value='$r'> Yes <input type=radio name='key' value='' checked> No</td><td><i>Set a random key to encrypt user passwords.</i></td></tr>
<tr><td>CleanURLs:</td><td><input type=radio name='htaccess' value='yes'> Yes <input type=radio name='htaccess' value='no' checked> No</td><td><i>Include htaccess rules for cleanURLs.</i></td></tr>
$root_exists
</table><br>
<input type=submit value='Create Site'>
</form>";

$page['error'] = "<h1>Password Error</h1>
Your password is too short. Please make sure it includes at least 8 characters.<br><br>
<a href='start.php'>Click here</a> to try again.";

$page['invalid'] = "<h1>Invalid Password</h1>
You must enter the correct system password to create a new site.<br><br>
<a href='start.php'>Click here</a> to try again.";

$page['badfield'] = "<h1>Invalid Field</h1>
One of the form fields you entered was not accepted.<br><br>
<a href='start.php'>Click here</a> to try again.";

$page['exists'] = "<h1>Site Exists</h1>
A site already exists with this id. Please choose another.<br><br>
<a href='start.php'>Try again</a>";

$page['complete'] = "<h1>Congratulations</h1>
Site successfully created. Click here to begin building your new site:<br><br>
<a href='$site'>$site</a><br><br>
Note: Be sure to setup your superadmin account promptly.";

$page['disabled'] = "<h1>Disabled</h1>
The site auto creator has been disabled for this installation of BoltWire.<br><br>
For information about how to restore this feature, please read the documentation at <a href='http://www.boltwire.com/docs/concepts/start'>www.boltwire.com</a>.";

$page['root'] = "<h1>Root Exists</h1>
An index.php file already exists in the root directory. Coult not create.<br><br>
<a href='start.php'>Try again</a>";

// MAIN SCRIPT CONTROLLING SITE CREATION
if (! isset($pass)) {
	if (! isset($_POST['password'])) showPage('welcome');
	else setPassword();
	}
elseif ($pass == crypt('false', 'false')) showPage('disabled');  
elseif (! isset($_POST['site'])) showPage('setup');
else {  
	setField();
	clearstatcache();
	showPage('complete');
	}
exit;


// UTILITIES USED BY THIS SCRIPT
function showPage($p) {
	global $page;
	$head = "<html><body bgcolor=#c0c0c0 style='margin: 100px;'><table align=center bgcolor=white border=0 width=1000 cellpadding=50px cellspacing=0px><tr><td><font size=+2>";
	$foot = "</font></td></tr></table></body></html>";	
	print_r($head . $page[$p] . $foot);
	exit;
	}

function setPassword() {
	global $htcodes;
	$password = crypt($_POST['password'], $_POST['password']);
	if ($_POST['password'] == 'false') {
		savePage($htcodes, $password);
		showPage('disabled');
		}
	if (strlen($_POST['password']) < 8) showPage('error');
	savePage($htcodes, $password);
	showPage('setup');
	}

function setField() {
	if (! isset($_POST['password']) || ! isset($_POST['site'])) showPage('setup');
	global $pass, $boltwire, $root, $site, $field;
	if ($pass != crypt($_POST['password'], $_POST['password'])) showPage('invalid');
	if (preg_match('/^[-_a-z0-9]+$/', $_POST['site']) == 0) showPage('badfield');
	if (preg_match('/^[-_a-z0-9]+$/', $_POST['admin']) == 0) showPage('badfield');
	$path = "$root/$field$_POST[site]";
	if (file_exists($path)) showPage('exists');
	if (isset($_POST['root']) && $_POST['root'] == 'yes') {
		if (file_exists("$root/index.php")) showPage('root');
		}
	mkdir($path);
	chmod($path, 0777);
	if ($_POST['key'] != '') $key = "\n\$cryptkey = '$_POST[key]';";
	else $key = '';
	$content = "<?php\n\$BOLTadmin = '[admin]';[key]\n\$boltwire = '$boltwire';\ninclude_once(\"\$boltwire/scripts/engine.php\");";
	$content = str_replace(Array('[admin]', '[key]'), Array($_POST['admin'], $key), $content);
	savePage("$path/index.php", $content);
	chmod("$path/index.php", 0666);
	if ($_POST['htaccess'] == 'yes') {
		$content = "Options -Indexes +FollowSymLinks\nRewriteEngine On\nRewriteCond %{REQUEST_FILENAME} !-f\nRewriteRule ^(.+)$ index.php?p=$1 [QSA,L]";
		savePage("$path/.htaccess", $content);
		}
	if (isset($_POST['root']) && $_POST['root'] == 'yes') {
		$content = "<?php\nheader('Location: $site');\nheader('Content-type: text/html');\nprint_r('<html><head><meta http-equiv=Refresh></head><body></body></html>');";
		savePage("$root/index.php", $content);
		}
	return;
	}

function savePage($location, $content) {
	$handle = fopen($location, "wb");
    fwrite($handle, $content);
    fclose($handle);
	return;
	}